%define upstream_name    Coro
%define upstream_version 6.49

%global __requires_exclude perl\\(Exporter::\\)|perl\\(Coro::Socket::\\)
# Filter underspecified dependencies
%global __requires_exclude %{?__requires_exclude:__requires_exclude|}^perl\\(AnyEvent\\)$
%global __requires_exclude %__requires_exclude|^perl\\(AnyEvent\\) >= 4.800001$
%global __requires_exclude %__requires_exclude|^perl\\(Guard\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Storable\\)$
%global __provides_exclude %{?__provides_exclude:__provides_exclude|}^perl\\(Coro\\)$

#define _without_check 1

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %upstream_version
Release:    %mkrel 3
Epoch:      3

Summary:    Coroutine process abstraction
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}
Source0:    http://search.cpan.org/CPAN/authors/id/M/ML/MLEHMANN/%{upstream_name}-%{upstream_version}.tar.gz
Patch0:         %{name}-5.25-ucontext-default.patch

BuildRequires: perl(AnyEvent) >= 5.0.0
BuildRequires: perl(Canary::Stability)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Guard) >= 0.500.0
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 2.150.0
BuildRequires: perl(common::sense)
BuildRequires: perl-devel
BuildRequires: perl-AnyEvent >= 1:4.05
BuildRequires: perl-EV >= 2.0
BuildRequires: perl-Event
BuildRequires: perl-Guard
BuildRequires: perl-IO-AIO
Obsoletes:  perl-Coro-EV       <= 2:6.330.0
Obsoletes:  perl-Coro-AnyEvent <= 2:6.330.0
Obsoletes:  perl-Coro-BDB      <= 2:6.330.0

%description
This module collection manages continuations in general, most often in the
form of cooperative threads (also called coros, or simply "coro" in the
documentation). They are similar to kernel threads but don't (in general) run
in parallel at the same time even on SMP machines. The specific flavor of
thread offered by this module also guarantees you that it will not switch
between threads unless necessary, at easily-identified points in your
program, so locking and parallel access are rarely an issue, making thread
programming much safer and easier than using other thread models.


%prep
%setup -q -n %{upstream_name}-%{upstream_version} 
%ifnarch %{ix86} x86_64 %{arm}
# use ucontext backend on non-x86 (setjmp didn't work on s390(x))
%patch0 -p1 -b .ucontext-default
%endif
# change shebang lines if needed
perl -pi -e 's{/opt/bin/perl}{/usr/bin/perl}' eg/* Coro/*
# remove failing test - http://rt.cpan.org/Ticket/Display.html?id=32475
rm EV/t/01_unblock.t

%build
# Disable FORTIFY_SOURCE on ARM as it breaks setjmp - RHBZ 750805
%ifarch %{arm}
RPM_OPT_FLAGS="${RPM_OPT_FLAGS} -Wp,-U_FORTIFY_SOURCE -Wp,-D_FORTIFY_SOURCE=0"
%endif

# Interractive configuration. Use default values.
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="$RPM_OPT_FLAGS" </dev/null
make

%install
%make_install

%check
%{!?_without_check:make test}

%files
%license COPYING
%doc Changes EV INSTALL META.json META.yml MYMETA.yml README eg
%{perl_vendorarch}/*
%_mandir/man3/*


%changelog
* Thu Jun 16 2016 tv <tv> 3:6.490.0-3.mga6
+ Revision: 1021646
- better description
- use %%license
- do use our flags (fixing arm build)

* Wed Jun 15 2016 tv <tv> 3:6.490.0-2.mga6
+ Revision: 1021549
- add arm fixes from FC

* Sun May 08 2016 shlomif <shlomif> 3:6.490.0-1.mga6
+ Revision: 1010575
- update to 6.49

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Thu Nov 19 2015 neoclust <neoclust> 3:6.480.0-3.mga6
+ Revision: 904257
- Rebuild on arm

* Sun Nov 15 2015 tv <tv> 3:6.480.0-2.mga6
+ Revision: 903340
- new release

* Wed Oct 21 2015 tv <tv> 3:6.470.0-2.mga6
+ Revision: 893415
- rebuild with fixed deps

* Mon Jul 13 2015 sander85 <sander85> 3:6.470.0-1.mga6
+ Revision: 853589
- update to 6.47

* Thu Jul 02 2015 tv <tv> 3:6.460.0-1.mga6
+ Revision: 849561
- new release
- new release
- rebuild for soname-ifed perl
- just accept defaults
- BR perl(Canary::Stability)
- new release
- rebuild for perl-5.22

* Wed Oct 15 2014 umeabot <umeabot> 2:6.410.0-5.mga5
+ Revision: 749970
- Second Mageia 5 Mass Rebuild

* Tue Sep 30 2014 tv <tv> 2:6.410.0-4.mga5
+ Revision: 732962
- add exclude

* Tue Sep 16 2014 umeabot <umeabot> 2:6.410.0-3.mga5
+ Revision: 684025
- Mageia 5 Mass Rebuild

  + tv <tv>
    - use %%global for req/prov exclude
    - autoconvert to new prov/req excludes

* Sun Sep 07 2014 sander85 <sander85> 2:6.410.0-2.mga5
+ Revision: 673118
- update to 6.41

* Wed Jun 04 2014 sander85 <sander85> 2:6.390.0-2.mga5
+ Revision: 632975
- bump rel
- update to 6.39

  + jquelin <jquelin>
    - perl 5.20.0 rebuild

* Fri Mar 14 2014 jquelin <jquelin> 2:6.370.0-2.mga5
+ Revision: 603826
- update list of obsoletes
- update obsoletes

* Thu Mar 13 2014 jquelin <jquelin> 2:6.370.0-1.mga5
+ Revision: 602862
- update to 6.37

* Thu Mar 13 2014 jquelin <jquelin> 2:6.330.0-2.mga5
+ Revision: 602831
- get rid of subpackages

* Mon Feb 10 2014 jquelin <jquelin> 2:6.330.0-1.mga5
+ Revision: 588116
- update to 6.33

* Sat Oct 19 2013 umeabot <umeabot> 2:6.310.0-2.mga4
+ Revision: 526302
- Mageia 4 Mass Rebuild

* Mon Jun 03 2013 jquelin <jquelin> 2:6.310.0-1.mga4
+ Revision: 436485
- update to 6.31

* Wed May 29 2013 jquelin <jquelin> 2:6.230.0-3.mga4
+ Revision: 432090
- perl 5.18.0 rebuild

* Sun Jan 13 2013 umeabot <umeabot> 2:6.230.0-2.mga3
+ Revision: 364825
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 jquelin <jquelin> 2:6.230.0-1.mga3
+ Revision: 341970
- update to 6.23

* Mon Oct 15 2012 jquelin <jquelin> 2:6.100.0-1.mga3
+ Revision: 306069
- update to 6.10

* Fri Aug 24 2012 pterjan <pterjan> 2:6.80.0-2.mga3
+ Revision: 283466
- Rebuild for new perl

* Tue Jun 05 2012 jquelin <jquelin> 2:6.80.0-1.mga3
+ Revision: 254725
- update to 6.08

* Wed May 30 2012 jquelin <jquelin> 2:6.70.0-2.mga3
+ Revision: 250386
- rebuild for perl 5.16

* Fri Nov 11 2011 kharec <kharec> 2:6.70.0-1.mga2
+ Revision: 166824
- update to 6.07

  + jquelin <jquelin>
    - update to 6.06
    - update to 6.02

* Fri Jul 08 2011 jquelin <jquelin> 2:6.10.0-1.mga2
+ Revision: 120366
- update to 6.01

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-2.mga2
+ Revision: 116723
- rebuild
- remove erroneous shebangs

* Thu Jun 30 2011 jquelin <jquelin> 2:6.0.0-1.mga2
+ Revision: 116473
- update to 6.0

* Fri Feb 25 2011 jquelin <jquelin> 2:5.372.0-1.mga2
+ Revision: 59636
- update to 5.372

* Tue Feb 22 2011 jquelin <jquelin> 2:5.371.0-1.mga1
+ Revision: 56509
- update to 5.371

* Mon Jan 24 2011 jquelin <jquelin> 2:5.250.0-1.mga1
+ Revision: 37015
- adding missing buildrequires:
- remove blocking EV test
- shipping perl-Coro-EV
- mageia rebuild
- remove files not found
- mageia rebuild
- imported package perl-Coro

